

import java.util.*;



public class EdgePoint extends RealPoint {



    public static final int TOP		= 0;

    public static final int BOTTOM	= 1;

    public static final int LEFT	= 2;

    public static final int RIGHT	= 3;

    

    public EntityInstance e;

    public RelationClass rc;

 

    public double wf, hf;



    public boolean drawn = false;

    public boolean isDefault = true;

    public int side;



    public EdgePoint(EntityInstance e, RelationClass rc, double wf, double hf) {

	this.e = e;

	this.rc = rc;

	this.wf = wf;

	this.hf = hf;

    }



    public void rescale() {

	Layout lyt = e.getLayout();



	x = lyt.x + lyt.width*wf;

	y = lyt.y + lyt.height*hf;

    }



    public Object clone() {

	EdgePoint ne =  new EdgePoint(e, rc, wf, hf);



	ne.x = x;

	ne.y = y;

	ne.active = active;

	ne.elision = elision;



	return ne;

    }



    public boolean isBend() {

	return false;

    }



    public boolean isOver(int x, int y) {

	return e.isPointOverIO(this, x, y);

    }



    public String toString() {

	return "EP: (" + x + ", " + y + ")";

    }

}

